package com.fp.persistence.pgeneral.gene;

import javax.persistence.EmbeddedId;
import javax.persistence.Entity;
import javax.persistence.Column;
import javax.persistence.EntityManager;
import java.io.Serializable;
import javax.persistence.Table;

import com.fp.dto.hb.Cache;
import com.fp.dto.hb.HibernateBean;
import java.lang.reflect.Field;
import javax.persistence.Transient;

/**Clase que implementa la entidad de Hibernate que hace referencia a la tabla TGENEBALANCETYPE*/
@Entity(name="TgeneBalanceType")
@Table(name="TGENEBALANCETYPE")
public class TgeneBalanceType extends com.fp.dto.AbstractDataTransport implements Serializable,HibernateBean,Cloneable,Cache{
/**
* HashCode asociado con la Instancia
*/
@Transient
private int hashValue = 0;
/**
* Version de la Clase
*/
private static final long serialVersionUID = 1L;
/**
* Clave primaria de la Entidad TgeneBalanceType
*/
@EmbeddedId
private TgeneBalanceTypeKey pk;
@Column(name="DESCRIPTION", nullable=false)

/**
* Descripción del tipo de saldo
*/
private String description;

@Column(name="BALANCECATEGORY", nullable=true)

/**
* Categoria del tipo de saldo, Interes, Capita; Seguros, Cargos, Impuestos etc,
*/
private String balancecategory;

@Column(name="MODULECODE", nullable=true)

/**
* Codigo de modulo al que pertenece el tipo de saldo.
*/
private String modulecode;

@Column(name="CHARGEFORINSTALLMENT", nullable=true)

/**
* Y indica que el cargo sirve para incluir en tablas de amortizacion, N el cargo no va a tablas de amortizacion.
*/
private String chargeforinstallment;

/**Contructor por defecto*/
public TgeneBalanceType(){
}
/**Contructor de TgeneBalanceType
@param pPk Clave Primaria del entity
@param pDescription Descripción del tipo de saldo
*/
public TgeneBalanceType(TgeneBalanceTypeKey pPk,String pDescription){
 this();
 pk=pPk;
 description=pDescription;
}
/**
* Metodo que entrega datos de la tabla dada la clave primaria.
* @param pEntityManager referencia de la session a obtener datos del bean.
* @param pKey Caleve primaria del bean.
* @return TgeneBalanceType
*/
public static TgeneBalanceType find(EntityManager pEntityManager,TgeneBalanceTypeKey pKey) throws Exception{
    TgeneBalanceType obj = pEntityManager.find(TgeneBalanceType.class,pKey);
    return obj;
}
/**Entrega la Clave primaria de TgeneBalanceType
@return El objeto que referencia a la Clave primaria de TgeneBalanceType
*/
public TgeneBalanceTypeKey getPk(){
  return pk;
}
/**Fija un nuevo valor a la Clave primaria de TgeneBalanceType
@param pPk El objeto que referencia a la nueva Clave primaria de TgeneBalanceType
*/
public void setPk(TgeneBalanceTypeKey pPk){
  pk=pPk;
}
/**Obtiene el valor de description
@return valor de description*/
public String getDescription(){
  return description;
}
/**Fija el valor de description
@param pDescription nuevo Valor de description*/
public void setDescription(String pDescription){
  description=pDescription;
}

/**Obtiene el valor de balancecategory
@return valor de balancecategory*/
public String getBalancecategory(){
  return balancecategory;
}
/**Fija el valor de balancecategory
@param pBalancecategory nuevo Valor de balancecategory*/
public void setBalancecategory(String pBalancecategory){
  balancecategory=pBalancecategory;
}

/**Obtiene el valor de modulecode
@return valor de modulecode*/
public String getModulecode(){
  return modulecode;
}
/**Fija el valor de modulecode
@param pModulecode nuevo Valor de modulecode*/
public void setModulecode(String pModulecode){
  modulecode=pModulecode;
}

/**Obtiene el valor de chargeforinstallment
@return valor de chargeforinstallment*/
public String getChargeforinstallment(){
  return chargeforinstallment;
}
/**Fija el valor de chargeforinstallment
@param pChargeforinstallment nuevo Valor de chargeforinstallment*/
public void setChargeforinstallment(String pChargeforinstallment){
  chargeforinstallment=pChargeforinstallment;
}

public boolean equals(Object rhs){
    if (rhs == null)return false;
    if (! (rhs instanceof TgeneBalanceType))return false;
    TgeneBalanceType that = (TgeneBalanceType) rhs;
    if (this.getPk() == null || that.getPk() == null)
        return false;
    return (this.getPk().equals(that.getPk()));
}
/**Implementación del metodo hashCode de la la entidad TgeneBalanceType
@return el hashCode la instancia
*/
public int hashCode()    {
    if (this.hashValue == 0){
        int result = 17;
        if (this.getPk() == null){
            result = super.hashCode();
        }else{
            result = this.getPk().hashCode();
        }
        this.hashValue = result;
    }
    return this.hashValue;
}
/**Implementación toString
*/
public String toString() {
	Field[]fs=this.getClass().getDeclaredFields();
	String data="";
	for(Field f:fs){
	 try{	
	 String name=f.getName();
   if(f.getType().getName().compareTo("java.util.Set")==0)continue;
	 if(name.compareTo("hashValue")==0||name.compareTo("serialVersionUID")==0)continue;
		data+=name+"="+f.get(this)+";";
	 }catch(Exception e){
		 continue;
	 }
		}
		if(data.compareTo("")==0){
		data=super.toString();
		}
	return data;
	}
/**Implementación de la creación de un bean en blanco TgeneBalanceType
*/
public Object createInstance(){
 TgeneBalanceType instance=new TgeneBalanceType();	
 instance.setPk(new TgeneBalanceTypeKey());
 return instance;
}
/**Clona la entidad TgeneBalanceType
@see com.fp.dto.hb.HibernateBean#cloneMe()
*/
public Object cloneMe() throws CloneNotSupportedException{
  TgeneBalanceType p=(TgeneBalanceType)this.clone();
  p.setPk((TgeneBalanceTypeKey)this.pk.cloneMe());
  return p;
}
}
